% Copyright (c) 2010 Iris Yan

% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.

% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

clear all
%-------Parameters----------------------------
Et=500;
beta =3.5;
sigma0=4.3;
N=20;
sigma=getsigma(sigma0,N);
tau_i=1;
tau_o=1;
beta=3.5;
v0=80;
v=v0*5/18;
v0=[1:5:100];
er=0.1;
P_f=0.1;P_b=0.1;
side_length=200; %Side length of the square area
p_w=0.8;

%----------Network Parameters--------------------------
R1=100;x_AP1= 0;y_AP1=0;bandwidth1=1000;money1=2;security1=2;power1=2;%WLAN2 parameters
R2=80;x_AP2= 20;y_AP2=0;bandwidth2=2000;money2=3;security2=1;power2=3;%WLAN1 parameters
bandwidth3=384;money3=5;security3=7;power3=1;%UMTS parameters

% PlotCircle(x_AP1,y_AP1,R1,40,'b');
% PlotCircle(x_AP2,y_AP2,R2,40,'r');
for i=1:length(v0)
    v(i)=v0(i).*5/18;
    total_satisfaction(i)=0;total_satisfaction_WLAN1(i)=0;total_satisfaction_WLAN2(i)=0;total_satisfaction_UMTS(i)=0;
    num_failure(i)=0;num_breakdown(i)=0;num_unnecessary(i)=0;
    for j = 1 : 1000 %Generating 100 trajectories
        exp_bandwidth(i,j)=100+randint(1,1,901);exp_money(i,j)=1+randint(1,1,11);exp_security(i,j)=1+randint(1,1,11);
        i_bandwidth(i,j)=randint(1,1,4);i_cost(i,j)=randint(1,1,4);i_security(i,j)=randint(1,1,4);
        if i_bandwidth(i,j)~=0 || i_cost(i,j)~=0 || i_security(i,j)~=0
          [ w_bandwidth(i,j),w_cost(i,j),w_security(i,j),w_power(i,j) ] = weights( i_bandwidth(i,j),i_cost(i,j),i_security(i,j),p_w );
        else [ w_bandwidth(i,j),w_cost(i,j),w_security(i,j),w_power(i,j) ] = weights( 1,1,1,p_w );
        end
        theta_i(i,j)=2*pi*rand(1);
        theta_o(i,j)=2*pi*rand(1);
        theta(i,j)=theta_i(i,j)-theta_o(i,j);
        if theta(i,j) < 0
            theta(i,j) = abs(theta(i,j));
        end
%         [x_start(j),y_start(j),x_end(j),y_end(j)]=generatepoints( side_length );
%        [d1(j)]=calculatedistance( x_AP1,y_AP1,x_start(j),y_start(j),x_end(j),y_end(j),R1 );
%        [d2(j)]=calculatedistance( x_AP2,y_AP2,x_start(j),y_start(j),x_end(j),y_end(j),R2 );
        d1(i,j)=sqrt(2*R1^2*(1-cos(theta(i,j)))); 
        p1(i,j)=sin(theta_o(i,j))-sin(theta_i(i,j));
        p2(i,j)=cos(theta_o(i,j))-cos(theta_i(i,j));
        p3(i,j)=-R1*cos(theta_i(i,j))*sin(theta_o(i,j))+R1*sin(theta_i(i,j))*cos(theta_o(i,j));
        p4(i,j)=sqrt(2*(1 - sin(theta_o(i,j))*sin(theta_i(i,j)) - cos(theta_o(i,j))*cos(theta_i(i,j)) ));
        d2_0(i,j)=abs( p1(i,j)*x_AP2 - p2(i,j)*y_AP2 + p3(i,j) ) / p4(i,j);
        
        if d2_0(i,j)<R2
        d2(i,j)=2*sqrt(R2^2-d2_0(i,j)^2);
        else d2(i,j)=0;
        end
        [ handover1(i,j),failure1(i,j),unnecessary1(i,j) ] = HNE( beta,Et,R1,sigma,tau_i,tau_o,P_f,v(i),d1(i,j) );
        NetworkID1(i,j)=3;time_WLAN1(i,j)=0;breakdown1(i,j)=0;act_bandwidth1(i,j)=bandwidth3;act_money1(i,j)=money3;act_security1(i,j)=security3;
        if handover1(i,j)~=0
            [ NetworkID1(i,j),act_bandwidth1(i,j),act_money1(i,j),act_security1(i,j) ] = HTS( i_bandwidth(i,j),i_cost(i,j),i_security(i,j),p_w,bandwidth1,money1,security1,power1,1,100,1,100,bandwidth3,money3,security3,power3 );
            if NetworkID1(i,j)==1
                [ time_WLAN1(i,j),breakdown1(i,j) ] = HTCE( beta,Et,R1,sigma,tau_i,tau_o,P_b,v(i),d1(i,j),er );
            end
        end
        NetworkID2(i,j)=NetworkID1(i,j);time_WLAN2(i,j)=0;breakdown2(i,j)=0;act_bandwidth2(i,j)=act_bandwidth1(i,j);act_money2(i,j)=act_money1(i,j);act_security2(i,j)=act_security1(i,j);
        handover2(i,j)=0;failure2(i,j)=0;unnecessary2(i,j)=0;
        if d2(i,j)~=0
            [ handover2(i,j),failure2(i,j),unnecessary2(i,j) ] = HNE( beta,Et,R2,sigma,tau_i,tau_o,P_f,v(i),d2(i,j) );
            if handover2(i,j)~=0
                [ NetworkID2(i,j),act_bandwidth2(i,j),act_money2(i,j),act_security2(i,j) ] = HTS( i_bandwidth(i,j),i_cost(i,j),i_security(i,j),p_w,bandwidth1,money1,security1,power1,bandwidth2,money2,security2,power2,bandwidth3,money3,security3,power3 );
                if NetworkID2==2
                    [ time_WLAN2(i,j),breakdown2(i,j) ] = HTCE( beta,Et,R2,sigma,tau_i,tau_o,P_b,v(i),d2(i,j),er );
                end
            end
        end
        time_WLAN1(i,j)=time_WLAN1(i,j)-time_WLAN2(i,j);
        satisfaction1(i,j)=(act_bandwidth1(i,j)-exp_bandwidth(i,j))/act_bandwidth1(i,j)*w_bandwidth(i,j) + (exp_money(i,j)-act_money1(i,j))/act_money1(i,j)*w_cost(i,j) + (act_security1(i,j)-exp_security(i,j))/act_security1(i,j)*w_security(i,j);
        satisfaction2(i,j)=(act_bandwidth2(i,j)-exp_bandwidth(i,j))/act_bandwidth2(i,j)*w_bandwidth(i,j) + (exp_money(i,j)-act_money2(i,j))/act_money2(i,j)*w_cost(i,j) + (act_security2(i,j)-exp_security(i,j))/act_security2(i,j)*w_security(i,j);
        satisfaction(i,j)=satisfaction1(i,j)*d1(i,j)/(d1(i,j)+d2(i,j))+satisfaction2(i,j)*d2(i,j)/(d1(i,j)+d2(i,j));
        satisfaction_WLAN1(i,j)=(bandwidth1-exp_bandwidth(i,j))/bandwidth1*w_bandwidth(i,j) + (exp_money(i,j)-money1)/money1*w_cost(i,j) + (security1-exp_security(i,j))/security1*w_security(i,j);
        satisfaction_WLAN1(i,j)=satisfaction_WLAN1(i,j);
        satisfaction_WLAN2(i,j)=(bandwidth2-exp_bandwidth(i,j))/bandwidth2*w_bandwidth(i,j) + (exp_money(i,j)-money2)/money2*w_cost(i,j) + (security2-exp_security(i,j))/security2*w_security(i,j);
        satisfaction_WLAN2(i,j)=satisfaction_WLAN2(i,j);
        satisfaction_UMTS(i,j)=(bandwidth3-exp_bandwidth(i,j))/bandwidth3*w_bandwidth(i,j) + (exp_money(i,j)-money3)/money3*w_cost(i,j) + (security3-exp_security(i,j))/security3*w_security(i,j);
        satisfaction_UMTS(i,j)=satisfaction_UMTS(i,j);
        total_satisfaction(i)=total_satisfaction(i)+satisfaction(i,j);
        total_satisfaction_WLAN1(i)=total_satisfaction_WLAN1(i)+satisfaction_WLAN1(i,j);
        total_satisfaction_WLAN2(i)=total_satisfaction_WLAN2(i)+satisfaction_WLAN2(i,j);
        total_satisfaction_UMTS(i)=total_satisfaction_UMTS(i)+satisfaction_UMTS(i,j);
        num_failure(i)=num_failure(i)+failure1(i,j)+failure2(i,j);
        num_breakdown(i)=num_breakdown(i)+breakdown1(i,j)+breakdown2(i,j);
        num_unnecessary(i)=num_unnecessary(i)+unnecessary1(i,j)+unnecessary2(i,j);
    end
    ave_satisfaction(i)=total_satisfaction(i)/j;
    ave_satisfaction_WLAN1(i)=total_satisfaction_WLAN1(i)/j;
    ave_satisfaction_WLAN2(i)=total_satisfaction_WLAN2(i)/j;
    ave_satisfaction_UMTS(i)=total_satisfaction_UMTS(i)/j;
    ave_failure(i)=num_failure(i);
    ave_breakdown(i)=num_breakdown(i);
    ave_unnecessary(i)=num_unnecessary(i);
end

figure
plot(v0,ave_failure,'b+:','LineWidth',2);
grid  ('on')
xlabel('Velocity (km/h)')
ylabel('Number of Handover Failures')

figure
plot(v0,ave_unnecessary,'-r','LineWidth',2);
grid  ('on')
xlabel('Velocity (km/h)')
ylabel('Number of Unecessary Handovers')

figure
plot(v0,ave_breakdown,'--g','LineWidth',2);
grid  ('on')
xlabel('Velocity (km/h)')
ylabel('Number of Connection Breakdowns')

figure
plot(v0,ave_satisfaction,'c+:','LineWidth',2);
hold on
plot(v0,ave_satisfaction_WLAN2,'-r','LineWidth',2);
hold on
plot(v0,ave_satisfaction_WLAN1,'--g','LineWidth',2);
hold on
plot(v0,ave_satisfaction_UMTS,'-y','LineWidth',2);
hold on
legend('Proposed','Always choosing network1','Always choosing network2','Always choosing network3');
grid  ('on')
xlabel('Velocity (km/h)')
ylabel('User''s Satisfaction')
%         flag_WLAN1=1;
%         flag_WLAN2=1;
%         flag1=1;flag2=1;flag3=1;
%         total_distance(j)=sqrt((y_end(j)-y_start(j))^2+(x_end(j)-x_start(j))^2);
%         l=1;
%         gradient(j)=(y_end(j)-y_start(j))/(x_end(j)-x_start(j));
%         theta(j)=atan(gradient(j));
%         for k=1:floor(total_distance(j))
%         x_P(j,k)=l*cos(theta(j))+x_start(j);
%         y_P(j,k)=l*sin(theta(j))+y_start(j);
%         l=l+1;
%             [cross_WLAN1(j)]=judgecross(R1,x_P(j),y_P(j,k),x_AP1,y_AP1);
%             [cross_WLAN2(j)]=judgecross(R2,x_P(j),y_P(j,k),x_AP2,y_AP2);
%             if cross_WLAN1(j)==1 && flag_WLAN1==1
%                 [ d1(j) ] = calculatedistance( x_AP1,y_AP1,x_start(j),y_start(j),x_end(j),y_end(j),R1 );
%                 [ handover1(j),failure1(j),unnecessary1(j) ] = HNE( beta,Et,R1,sigma,tau_i,tau_o,P_f,v,d1(j) );
%                 flag_WLAN1=0;
%             else
%                 handover1(j)=0;
%                 failure1(j)=0;
%                 unnecessary1(j)=0;
%             end
%             
%             if cross_WLAN2(j)==1 && flag_WLAN2==1
%                 [ d2(j) ] = calculatedistance( x_AP2,y_AP2,x_start(j),y_start(j),x_end(j),y_end(j),R2 );
%                 [ handover2(j),failure2(j),unnecessary2(j) ] = HNE( beta,Et,R2,sigma,tau_i,tau_o,P_f,v,d2(j) );
%                 flag_WLAN2=0;
%             else
%                 handover2(j)=0;
%                 failure2(j)=0;
%                 unnecessary2(j)=0;    
%             end
%             
%             if handover1(j)==1 && handover2(j)==0 
%                 NetworkID(j,k)=1;act_bandwidth(j,k)=bandwidth1;act_money(j,k)=money1;act_security(j,k)=security1;
%                 satisfaction(j,k)=(act_bandwidth(j,k)-exp_bandwidth(j))/act_bandwidth(j,k)*w_bandwidth(j) + (exp_money(j)-act_money(j,k))/act_money(j,k)*w_cost(j) + (act_security(j,k)-exp_security(j))/act_security(j,k)*w_security(j);
%                 if flag1==1
%                 [ time_WLAN1(j),breakdown1(j) ] = HTCE( beta,Et,R1,sigma,tau_i,tau_o,P_b,v,d1(j),er );
%                 time_WLAN2(j)=0;breakdown2(j)=0;
%                 flag1=0;
%                 end
%             elseif handover1(j)==0 && handover2(j)==1 
%                 NetworkID(j,k)=2;act_bandwidth(j,k)=bandwidth2;act_money(j,k)=money2;act_security(j,k)=security2;
%                 satisfaction(j,k)=(act_bandwidth(j,k)-exp_bandwidth(j))/act_bandwidth(j,k)*w_bandwidth(j) + (exp_money(j)-act_money(j,k))/act_money(j,k)*w_cost(j) + (act_security(j,k)-exp_security(j))/act_security(j,k)*w_security(j);
%                 if flag2==1;
%                 [ time_WLAN2(j),breakdown2(j) ] = HTCE( beta,Et,R2,sigma,tau_i,tau_o,P_b,v,d2(j),er );
%                 time_WLAN1(j)=0;breakdown1(j)=0;
%                 flag2=0;
%                 end
%             elseif handover1(j)==1 && handover2(j)==1                 
%                 [ NetworkID(j,k),act_bandwidth(j,k),act_money(j,k),act_security(j,k) ] = HTS( i_bandwidth(j),i_cost(j),i_security(j),p_w,bandwidth1,money1,security1,power1,bandwidth2,money2,security2,power2,bandwidth3,money3,security3,power3 );
%                 satisfaction(j,k)=(act_bandwidth(j,k)-exp_bandwidth(j))/act_bandwidth(j,k)*w_bandwidth(j) + (exp_money(j)-act_money(j,k))/act_money(j,k)*w_cost(j) + (act_security(j,k)-exp_security(j))/act_security(j,k)*w_security(j);
%                 if flag3==1;
%                 if NetworkID==1
%                     [ time_WLAN1(j),breakdown1(j) ] = HTCE( beta,Et,R1,sigma,tau_i,tau_o,P_b,v,d1(j),er );
%                     time_WLAN2(j)=0;breakdown2(j)=0;
%                 elseif NetworkID==2
%                     [ time_WLAN2(j),breakdown2(j) ] = HTCE( beta,Et,R2,sigma,tau_i,tau_o,P_b,v,d2(j),er );
%                     time_WLAN1(j)=0;breakdown1(j)=0;
%                 else
%                     time_WLAN1(j)=0;breakdown1(j)=0;
%                     time_WLAN2(j)=0;breakdown2(j)=0;
%                 end
%                 flag3=0;
%                 end
%             else 
%                 breakdown1(j)=0;breakdown2(j)=0;
%                 NetworkID(j,k)=3;act_bandwidth(j,k)=bandwidth3;act_money(j,k)=money3;act_security(j,k)=security3;
%                 satisfaction(j,k)=(act_bandwidth(j,k)-exp_bandwidth(j))/act_bandwidth(j,k)*w_bandwidth(j) + (exp_money(j)-act_money(j,k))/act_money(j,k)*w_cost(j) + (act_security(j,k)-exp_security(j))/act_security(j,k)*w_security(j);
%             end
% 
%         end
%             num_failure=num_failure+failure1(j);
%             num_unnecessary=num_unnecessary+unnecessary1(j);
%             num_failure=num_failure+failure2(j);
%             num_unnecessary=num_unnecessary+unnecessary2(j);
%             num_breakdown=num_breakdown+breakdown1(j)+breakdown2(j);
% %             total_time_WLAN1=total_time_WLAN1+time_WLAN1(j);
% %             total_time_WLAN2=total_time_WLAN2+time_WLAN2(j);
%             
%             total_satisfaction(j)=satisfaction(j)+satisfaction(j,k);
%     end
                
                
%         d(i,j)=sqrt(2*R^2*(1-cos(theta(i,j)))); 
%         l_OM(i,j) = sqrt(R^2-(d(i,j)/2).^2);
%         RSS_M(i,j)=10*log10(Et)-10*beta*log10(l_OM(i,j));
%         d_R(i,j)=1/2*d(i,j);
%         
%         %Theoretical traveling distance for the fixed RSS threshold method
%         if l_OM(i,j)<R_fixed %Condition C1
%             d_r_fixed(i,j)=sqrt(R_fixed^2-1/2*R^2*(1+cos(theta(i,j))));
%             d_b_fixed(i,j)=d_R(i,j)-d_r_fixed(i,j);
%         else %Condition C2
%             d_b_fixed(i,j)=d_R(i,j);
%         end
%         %Actual traveling distance for the fixed RSS threshold method
%         noise1_fixed(i,j) = getnoise(sigma);
%         RSS_M_fixed_est(i,j) = RSS_M(i,j)+noise1_fixed(i,j);
%         l_OM_fixed_est(i,j) = 10^((10*log10(Et)-RSS_M_fixed_est(i,j))/10/beta);
%         if l_OM_fixed_est(i,j)<R_fixed %Condition C1
%             noise2_fixed(i,j) = getnoise(sigma);
%             RSS_fixed_est(i,j) = RSS_fixed+noise2_fixed(i,j);
%             R_fixed_est(i,j) = 10^((10*log10(Et)-RSS_fixed_est(i,j))/10/beta);
%             if R_fixed_est(i,j)>=R
%                 num_breakdown_fixed(i) = num_breakdown_fixed(i)+1;
%             elseif R_fixed_est(i,j)<=l_OM(i,j)
%                 if d_R(i,j)<v(i)*tau_o
%                     num_breakdown_fixed(i) = num_breakdown_fixed(i)+1;
%                 end                
%             else
%             d_r_fixed_est(i,j)=sqrt(R_fixed_est(i,j)^2-1/2*R^2*(1+cos(theta(i,j))));
%             d_b_fixed_est(i,j)=d_R(i,j)-d_r_fixed_est(i,j);
%             if d_b_fixed_est(i,j)<=v(i)*tau_o
%                 num_breakdown_fixed(i) = num_breakdown_fixed(i)+1;
%             end
%             end
%         else %Condition C2
%             if l_OM_fixed_est(i,j)>=R
%                 num_breakdown_fixed(i) = num_breakdown_fixed(i)+1;
%             else
%             d_R_fixed_est(i,j) = sqrt(R^2-l_OM_fixed_est(i,j)^2);
%             d_b_fixed_est(i,j) = d_R_fixed_est(i,j);
%             if d_b_fixed_est(i,j)<=v(i)*tau_o
%                 num_breakdown_fixed(i) = num_breakdown_fixed(i)+1;
%             end
%             end
%         end
%             
%                
%         %Theoretical traveling distance for the hysteresis method
%         if l_OM(i,j)<R_hyst %Condition C1
%             d_r_hyst(i,j)=sqrt(R_hyst^2-1/2*R^2*(1+cos(theta(i,j))));
%             d_b_hyst(i,j)=d_R(i,j)-d_r_hyst(i,j);
%         else %Condition C2
%             d_b_hyst(i,j)=d_R(i,j);
%         end
%         %Actual traveling distance for the fixed RSS threshold method
%         noise1_hyst(i,j) = getnoise(sigma);
%         RSS_M_hyst_est(i,j) = RSS_M(i,j)+noise1_hyst(i,j);
%         l_OM_hyst_est(i,j) = 10^((10*log10(Et)-RSS_M_hyst_est(i,j))/10/beta);
%         if l_OM_hyst_est(i,j)<R_hyst %Condition C1
%             noise2_hyst(i,j) = getnoise(sigma);
%             RSS_hyst_est(i,j) = RSS_hyst+noise2_hyst(i,j);
%             R_hyst_est(i,j) = 10^((10*log10(Et)-RSS_hyst_est(i,j))/10/beta);
%             if R_hyst_est(i,j)>=R
%                 num_breakdown_hyst(i) = num_breakdown_hyst(i)+1;
%             elseif R_hyst_est(i,j)<=l_OM(i,j)
%                 if d_R(i,j)<v(i)*tau_o
%                     num_breakdown_hyst(i) = num_breakdown_hyst(i)+1;
%                 end  
%             else 
%             d_r_hyst_est(i,j)=sqrt(R_hyst_est(i,j)^2-1/2*R^2*(1+cos(theta(i,j))));
%             d_b_hyst_est(i,j)=d_R(i,j)-d_r_hyst_est(i,j);
%             if d_b_hyst_est(i,j)<=v(i)*tau_o
%                 num_breakdown_hyst(i) = num_breakdown_hyst(i)+1;
%             end
%             end
%         else %Condition C2
%             if l_OM_hyst_est(i,j)>=R
%                 num_breakdown_hyst(i) = num_breakdown_hyst(i)+1;
%             else
%             d_R_hyst_est(i,j) = sqrt(R^2-l_OM_hyst_est(i,j)^2);
%             d_b_hyst_est(i,j) = d_R_hyst_est(i,j);
%             if d_b_hyst_est(i,j)<=v(i)*tau_o
%                 num_breakdown_hyst(i) = num_breakdown_hyst(i)+1;
%             end
%             end
%         end
%         
%         %Theoretical traveling distance for HTCE
%         r(i,j) = sqrt(v(i)^2*tau_o^2+R^2-v(i)*tau_o*R*sqrt(2*(1-cos(pi-pi*P_b))))*(1-er);
%         RSS_HTCE(i,j) = 10*log10(Et)-10*beta*log10(r(i,j));
%         if l_OM(i,j)<r(i,j) %Condition C1
%             d_r_HTCE(i,j)=sqrt(r(i,j)^2-1/2*R^2*(1+cos(theta(i,j))));
%             d_b_HTCE(i,j)=d_R(i,j)-d_r_HTCE(i,j);
%         else %Condition C2
%             d_b_HTCE(i,j)=d_R(i,j);
%         end
%         %Actual traveling distance for HTCE
%         noise1_HTCE(i,j) = getnoise(sigma);
%         RSS_M_HTCE_est(i,j) = RSS_M(i,j)+noise1_HTCE(i,j);
%         l_OM_HTCE_est(i,j) = 10^((10*log10(Et)-RSS_M_HTCE_est(i,j))/10/beta);
%         d_R_HTCE_est(i,j) = sqrt(R^2-l_OM_HTCE_est(i,j)^2);
%         d_predict_est(i,j) = d_R_HTCE_est(i,j)-d_R(i,j)*(1-er)+v(i)*tau_o;
%         if l_OM_HTCE_est(i,j)<r(i,j) %Condition C1
%             noise2_HTCE(i,j) = getnoise(sigma);
%             RSS_HTCE_est(i,j) = RSS_HTCE(i,j)+noise2_HTCE(i,j);
%             r_est(i,j) = 10^((10*log10(Et)-RSS_HTCE_est(i,j))/10/beta);
%             if r_est(i,j)>=R
%                 d_handover(i,j) = d_predict_est(i,j);
%                 d_b_HTCE_est(i,j)=0;
%             elseif r_est(i,j)<=l_OM(i,j)
%                 d_b_HTCE_est(i,j)=d_R(i,j);
%                 if d_predict_est(i,j)>d_R(i,j)
%                     d_handover(i,j) = d_predict_est(i,j);
%                 else d_handover(i,j) = d_R(i,j);
%                 end  
%             else
%             d_r_HTCE_est(i,j)=sqrt(r_est(i,j)^2-1/2*R^2*(1+cos(theta(i,j))));
%             d_b_HTCE_est(i,j)=d_R(i,j)-d_r_HTCE_est(i,j);
%             if d_predict_est(i,j)>d_b_HTCE_est(i,j)
%                 d_handover(i,j) = d_predict_est(i,j);
%             else d_handover(i,j) = d_b_HTCE_est(i,j);
%             end
%             end
%         else %Condition C2
%             if l_OM_HTCE_est(i,j)>=R
%                 d_handover(i,j) = 0;
%                 d_b_HTCE_est(i,j)=0;
%             else
%             d_b_HTCE_est(i,j) = d_R_HTCE_est(i,j);
%             if d_predict_est(i,j)>d_b_HTCE_est(i,j)
%                 d_handover(i,j) = d_predict_est(i,j);
%             else d_handover(i,j) = d_b_HTCE_est(i,j);
%             end
%             end
%         end
%         if d_handover(i,j)<v(i)*tau_o
%         num_breakdown_HTCE(i) = num_breakdown_HTCE(i)+1;
%         end
%         esterror(i,j) = abs(d_b_HTCE_est(i,j)-d_b_HTCE(i,j))/d_b_HTCE(i,j);
%         esterror_sum(i) = esterror_sum(i)+esterror(i,j); 
%         m = m+1;
%         
%     end
%     esterror_ave(i) = esterror_sum(i)/m;
% end

% figure
% plot(v0,num_breakdown_fixed/5000,'-.b','LineWidth',2);
% hold on
% plot(v0,num_breakdown_hyst/5000,'--g','LineWidth',2);
% hold on
% plot(v0,num_breakdown_HTCE/5000,'-r','LineWidth',2);
% hold on
% legend('Fixed RSS based','Hysteresis based','HTCE for P_b=0');
% grid  ('on')
% xlabel('Velocity (km/h)')
% ylabel('Number of Connection Breakdowns')
% 
% figure
% plot(v0,esterror_ave*100,'-.b','LineWidth',2);
% grid  ('on')
% xlabel('Velocity (km/h)')
% ylabel('Average Estimation Error Ratio (%)')


% figure
% plot(v0,num_failure_fixed./totalnum_handover_fixed,'-.b','LineWidth',2);
% hold on
% plot(v0,num_failure_hyst./totalnum_handover_hyst,'--g','LineWidth',2);
% hold on
% plot(v0,num_failure_HNE./totalnum_handover_HNE_pf,'-r','LineWidth',2);
% hold on
% legend('Fixed RSS based','Hysteresis based','HNE for P_f=0.02');
% grid  ('on')
% xlabel('Velocity (km/h)')
% ylabel('Ratio of Number of Handover Failures to Total Number of Handovers')    
    
