% Copyright (c) 2010 Iris Yan

% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.

% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function [ w_bandwidth,w_cost,w_security,w_power ] = weights( i_bandwidth,i_cost,i_security,p_w )
%This function distributes weights to decision parameters when input
%importance levels of three parameters and power level of the MT
i_H = 0.8;i_M = 0.4;i_L = 0.2; %importance factors determined by system designers
n_H = 0;n_M = 0;n_L = 0;
if i_bandwidth==3
    n_H=n_H+1;
elseif i_bandwidth==2
    n_M=n_M+1;
elseif i_bandwidth==1
    n_L=n_L+1;
end
if i_cost==3
    n_H=n_H+1;
elseif i_cost==2
    n_M=n_M+1;
elseif i_cost==1
    n_L=n_L+1;
end
if i_security==3
    n_H=n_H+1;
elseif i_security==2
    n_M=n_M+1;
elseif i_security==1
    n_L=n_L+1;
end

w_i_H=i_H*p_w/(n_H*i_H+n_M*i_M+n_L*i_L);
w_i_M=i_M*p_w/(n_H*i_H+n_M*i_M+n_L*i_L);
w_i_L=i_L*p_w/(n_H*i_H+n_M*i_M+n_L*i_L);

if i_bandwidth==3
    w_bandwidth=w_i_H;
elseif i_bandwidth==2
    w_bandwidth=w_i_M;;
elseif i_bandwidth==1
    w_bandwidth=i_L;
else w_bandwidth=0;
end
if i_cost==3
    w_cost=w_i_H;
elseif i_cost==2
    w_cost=w_i_M;
elseif i_cost==1
    w_cost=w_i_L;
else w_cost=0;
end
if i_security==3
    w_security=w_i_H;
elseif i_security==2
    w_security=w_i_M;
elseif i_security==1
    w_security=w_i_L;
else w_security=0;
end
w_power=1-p_w;

